#include <sys/thread.h>
#include <propeller.h>
#include "FullDuplexSerial.h"

#define Yield__() (__napuntil(_CNT))
extern inline int32_t Rotl__(uint32_t a, uint32_t b) { return (a<<b) | (a>>(32-b)); }
extern inline int32_t Rotr__(uint32_t a, uint32_t b) { return (a>>b) | (a<<(32-b)); }
#define Lookup__(x, b, a, n) __extension__({ int32_t i = (x)-(b); ((unsigned)i >= n) ? 0 : (a)[i]; })

uint8_t FullDuplexSerial::dat[] = {
  0xf0, 0xa9, 0xbc, 0xa0, 0x10, 0xa8, 0xfc, 0x80, 0x54, 0xaa, 0xbc, 0x08, 0x01, 0xb2, 0xfc, 0xa0, 
  0x55, 0xb2, 0xbc, 0x2c, 0x04, 0xa8, 0xfc, 0x80, 0x54, 0xaa, 0xbc, 0x08, 0x01, 0xbe, 0xfc, 0xa0, 
  0x55, 0xbe, 0xbc, 0x2c, 0x04, 0xa8, 0xfc, 0x80, 0x54, 0xae, 0xbc, 0x08, 0x04, 0xa8, 0xfc, 0x80, 
  0x54, 0xb0, 0xbc, 0x08, 0x04, 0xa8, 0xfc, 0x80, 0x54, 0xb4, 0xbc, 0x08, 0x5a, 0xc0, 0xbc, 0xa0, 
  0x10, 0xc0, 0xfc, 0x80, 0x04, 0xae, 0x7c, 0x62, 0x02, 0xae, 0x7c, 0x61, 0x5f, 0xe8, 0x9b, 0x68, 
  0x5f, 0xec, 0xab, 0x68, 0x33, 0xc8, 0xfc, 0xa0, 0x64, 0xbc, 0xbc, 0x5c, 0x01, 0xae, 0x7c, 0x62, 
  0xf2, 0xb3, 0x3c, 0x61, 0x16, 0x00, 0x64, 0x5c, 0x09, 0xb8, 0xfc, 0xa0, 0x58, 0xba, 0xbc, 0xa0, 
  0x01, 0xba, 0xfc, 0x28, 0xf1, 0xbb, 0xbc, 0x80, 0x58, 0xba, 0xbc, 0x80, 0x64, 0xbc, 0xbc, 0x5c, 
  0x5d, 0xa8, 0xbc, 0xa0, 0xf1, 0xa9, 0xbc, 0x84, 0x00, 0xa8, 0x7c, 0xc1, 0x1f, 0x00, 0x4c, 0x5c, 
  0xf2, 0xb3, 0x3c, 0x61, 0x01, 0xb6, 0xfc, 0x30, 0x1e, 0xb8, 0xfc, 0xe4, 0x17, 0xb6, 0xfc, 0x28, 
  0xff, 0xb6, 0xfc, 0x60, 0x01, 0xae, 0x7c, 0x62, 0xff, 0xb6, 0xd4, 0x6c, 0xf0, 0xab, 0xbc, 0x08, 
  0x5a, 0xaa, 0xbc, 0x80, 0x55, 0xb6, 0x3c, 0x00, 0x5a, 0xaa, 0xbc, 0x84, 0x01, 0xaa, 0xfc, 0x80, 
  0x0f, 0xaa, 0xfc, 0x60, 0xf0, 0xab, 0x3c, 0x08, 0x16, 0x00, 0x7c, 0x5c, 0x5e, 0xc8, 0xbc, 0x5c, 
  0xf0, 0xa9, 0xbc, 0xa0, 0x08, 0xa8, 0xfc, 0x80, 0x54, 0xaa, 0xbc, 0x08, 0x04, 0xa8, 0xfc, 0x80, 
  0x54, 0xac, 0xbc, 0x08, 0x56, 0xaa, 0x3c, 0x86, 0x33, 0x00, 0x68, 0x5c, 0x60, 0xac, 0xbc, 0x80, 
  0x56, 0xc2, 0xbc, 0x00, 0x60, 0xac, 0xbc, 0x84, 0x01, 0xac, 0xfc, 0x80, 0x0f, 0xac, 0xfc, 0x60, 
  0x54, 0xac, 0x3c, 0x08, 0x00, 0xc3, 0xfc, 0x68, 0x02, 0xc2, 0xfc, 0x2c, 0x01, 0xc2, 0xfc, 0x68, 
  0x0b, 0xc4, 0xfc, 0xa0, 0xf1, 0xc7, 0xbc, 0xa0, 0x04, 0xae, 0x7c, 0x62, 0x02, 0xae, 0x7c, 0x61, 
  0x01, 0xc2, 0xe0, 0x6c, 0x01, 0xc2, 0xfc, 0x29, 0x5f, 0xe8, 0xab, 0x70, 0x5f, 0xec, 0x97, 0x74, 
  0x58, 0xc6, 0xbc, 0x80, 0x5e, 0xc8, 0xbc, 0x5c, 0x63, 0xa8, 0xbc, 0xa0, 0xf1, 0xa9, 0xbc, 0x84, 
  0x00, 0xa8, 0x7c, 0xc1, 0x4d, 0x00, 0x4c, 0x5c, 0x46, 0xc4, 0xfc, 0xe4, 0x33, 0x00, 0x7c, 0x5c, 
};
int32_t FullDuplexSerial::Start(int32_t Rxpin, int32_t Txpin, int32_t Mode, int32_t Baudrate)
{
  int32_t _parm__0015[] = { Rxpin, Txpin, Mode, Baudrate };
  int32_t Okay = 0;
  Stop();
  { int32_t _fill__0016; int32_t *_ptr__0018 = (int32_t *)&Rx_head; int32_t _val__0017 = 0; for (_fill__0016 = 4; _fill__0016 > 0; --_fill__0016) {  *_ptr__0018++ = _val__0017; } };
  memmove( (void *)&Rx_pin, (void *)&_parm__0015[0], 4*(3));
  Bit_ticks = (_CLKFREQ / _parm__0015[3]);
  Buffer_ptr = (int32_t)(&Rx_buffer);
  Okay = (Cog = (cognew((int32_t)(&(*(int32_t *)&dat[0])), (int32_t)(&Rx_head)) + 1));
  return Okay;
}

int32_t FullDuplexSerial::Stop(void)
{
  int32_t result = 0;
  if (Cog) {
    cogstop((__extension__({ int32_t _tmp_ = Cog; Cog = 0; _tmp_; }) - 1));
  }
  { int32_t _fill__0019; int32_t *_ptr__0021 = (int32_t *)&Rx_head; int32_t _val__0020 = 0; for (_fill__0019 = 9; _fill__0019 > 0; --_fill__0019) {  *_ptr__0021++ = _val__0020; } };
  return result;
}

int32_t FullDuplexSerial::Rxflush(void)
{
  int32_t result = 0;
  while (Rxcheck() >= 0) {
    Yield__();
  }
  return result;
}

int32_t FullDuplexSerial::Rxcheck(void)
{
  int32_t Rxbyte = 0;
  (Rxbyte--);
  if (Rx_tail != Rx_head) {
    Rxbyte = Rx_buffer[Rx_tail];
    Rx_tail = ((Rx_tail + 1) & 15);
  }
  return Rxbyte;
}

int32_t FullDuplexSerial::Rxtime(int32_t Ms)
{
  int32_t Rxbyte = 0;
  int32_t	T;
  T = _CNT;
  while (!(((Rxbyte = Rxcheck()) >= 0) || (((_CNT - T) / (_CLKFREQ / 1000)) > Ms))) {
    Yield__();
  }
  return Rxbyte;
}

int32_t FullDuplexSerial::Rx(void)
{
  int32_t Rxbyte = 0;
  while ((Rxbyte = Rxcheck()) < 0) {
    Yield__();
  }
  return Rxbyte;
}

int32_t FullDuplexSerial::Tx(int32_t Txbyte)
{
  int32_t result = 0;
  while (!(Tx_tail != ((Tx_head + 1) & 15))) {
    Yield__();
  }
  Tx_buffer[Tx_head] = Txbyte;
  Tx_head = ((Tx_head + 1) & 15);
  if (Rxtx_mode & 8) {
    Rx();
  }
  return result;
}

int32_t FullDuplexSerial::Str(int32_t Stringptr)
{
  int32_t result = 0;
  int32_t _idx__0022;
  _idx__0022 = strlen((char *) Stringptr);
  do {
    Tx(((uint8_t *)(Stringptr++))[0]);
    _idx__0022 = (_idx__0022 + -1);
  } while (_idx__0022 >= 1);
  return result;
}

int32_t FullDuplexSerial::Dec(int32_t Value)
{
  int32_t result = 0;
  int32_t	I;
  if (Value < 0) {
    Value = (-Value);
    Tx('-');
  }
  I = 1000000000;
  int32_t _idx__0023;
  _idx__0023 = 10;
  do {
    if (Value >= I) {
      Tx(((Value / I) + '0'));
      Value = (Value % I);
      __extension__({ int32_t _tmp_ = result; result = -1; _tmp_; });
    } else {
      if ((result) || (I == 1)) {
        Tx('0');
      }
    }
    I = (I / 10);
    _idx__0023 = (_idx__0023 + -1);
  } while (_idx__0023 >= 1);
  return result;
}

int32_t FullDuplexSerial::Hex(int32_t Value, int32_t Digits)
{
  int32_t result = 0;
  Value = (Value << ((8 - Digits) << 2));
  int32_t _idx__0024;
  _idx__0024 = Digits;
  do {
    Tx(Lookup__(((Value = (Rotl__(Value, 4))) & 15), 0, ((int32_t[]){48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70, }), 16));
    _idx__0024 = (_idx__0024 + -1);
  } while (_idx__0024 >= 1);
  return result;
}

int32_t FullDuplexSerial::Bin(int32_t Value, int32_t Digits)
{
  int32_t result = 0;
  Value = (Value << (32 - Digits));
  int32_t _idx__0025;
  _idx__0025 = Digits;
  do {
    Tx((((Value = (Rotl__(Value, 1))) & 1) + '0'));
    _idx__0025 = (_idx__0025 + -1);
  } while (_idx__0025 >= 1);
  return result;
}

